@ECHO OFF
REM #############################################################
REM                CodeTyphon Project 
REM      Copyright  PilotLogic Software House.
REM               All rights reserved.
REM #############################################################


if NOT EXIST C:\Windows\SysWOW64 (
ECHO.
ECHO ???????????????????????????????????????????????????????????
ECHO   INFO: Sorry, Your Operating System NOT support 64Bits 
ECHO          can NOT build Lazarus for x86_64-win64               
ECHO ???????????????????????????????????????????????????????????
ECHO.
EXIT
)

ECHO.
ECHO =====================================================================
ECHO                  Build Lazarus for Win64 
ECHO =====================================================================
ECHO.

if NOT EXIST C:\pp\units\x86_64-win64\rtl\classes.o (
ECHO INFO: FreePascal Units for Win64 NOT EXIST !!!
CALL x_FPC_Win64_Build
IF NOT ERRORLEVEL 0 GOTO ERROR
)

if NOT EXIST c:\lazarus\Makefile.fpc (
ECHO INFO: Lazarus Source NOT EXIST !!!
CALL x_Lazarus_Exract_Source_from_ZipFile
IF NOT ERRORLEVEL 0 GOTO ERROR
)

ECHO.
ECHO -------------------------------------------------------
ECHO                  Prepare Lazarus Win64 
ECHO -------------------------------------------------------
ECHO.


IF NOT EXIST C:\lazarus\bin64\ (
mkdir C:\lazarus\bin64
IF NOT ERRORLEVEL 0 GOTO ERROR
ECHO INFO: create C:\lazarus\bin64 directory
)

IF EXIST C:\lazarus\lazarus.exe (
del /F /Q C:\lazarus\lazarus.exe
IF NOT ERRORLEVEL 0 GOTO ERROR
ECHO INFO: Removed lazarus.exe
)

IF EXIST C:\lazarus\startlazarus.exe (
del /F /Q C:\lazarus\startlazarus.exe
IF NOT ERRORLEVEL 0 GOTO ERROR
ECHO INFO: Removed startlazarus.exe
)

IF EXIST C:\lazarus\lazbuild.exe (
del /F /Q C:\lazarus\lazbuild.exe
IF NOT ERRORLEVEL 0 GOTO ERROR
ECHO INFO: Removed lazbuild.exe
)

IF EXIST C:\lazarus\xxlazarusWin32.txt (
del /F /Q C:\lazarus\xxlazarusWin32.txt
IF NOT ERRORLEVEL 0 GOTO ERROR
ECHO INFO: Removed xxlazarusWin32.txt
)

IF EXIST ..\binSettings\win64\lazarus.exe (
del /F /Q ..\binSettings\win64\lazarus.exe
IF NOT ERRORLEVEL 0 GOTO ERROR
del /F /Q ..\binSettings\win64\startlazarus.exe
IF NOT ERRORLEVEL 0 GOTO ERROR
del /F /Q ..\binSettings\win64\lazbuild.exe
IF NOT ERRORLEVEL 0 GOTO ERROR
ECHO INFO: Removed old building settings executables
)

IF EXIST ..\binSettings\win64user\lazarus.exe (
del /F /Q ..\binSettings\win64user\lazarus.exe
IF NOT ERRORLEVEL 0 GOTO ERROR
del /F /Q ..\binSettings\win64user\startlazarus.exe
IF NOT ERRORLEVEL 0 GOTO ERROR
del /F /Q ..\binSettings\win64user\lazbuild.exe
IF NOT ERRORLEVEL 0 GOTO ERROR
ECHO INFO: Removed old user settings executables
)

del /F /Q ..\binSettings\win64user\lazarus\*.*
IF NOT ERRORLEVEL 0 GOTO ERROR
copy /Y ..\bin\xxlazarusWin64.txt C:\lazarus\
IF NOT ERRORLEVEL 0 GOTO ERROR
CALL x_Lazarus_Settings_Restore
IF NOT ERRORLEVEL 0 GOTO ERROR
ECHO.
ECHO -------------------------------------------------------
ECHO                  Clean Lazarus Win64 
ECHO -------------------------------------------------------
ECHO.
PUSHD c:\lazarus\
C:\pp\bin\x86_64-win64\make.exe clean
IF NOT ERRORLEVEL 0 GOTO ERROR
popd  
ECHO.
ECHO -------------------------------------------------------
ECHO                  Compile Lazarus Win64 
ECHO -------------------------------------------------------
ECHO.

pushd c:\lazarus\
C:\pp\bin\x86_64-win64\make.exe bigide
IF NOT ERRORLEVEL 0 GOTO ERROR
popd  

IF NOT EXIST c:\lazarusTemp\ (
mkdir c:\lazarusTemp
IF NOT ERRORLEVEL 0 GOTO ERROR
ECHO INFO: create c:\lazarusTemp directory.
)

CALL x_Lazarus_User_Settings_Save
IF NOT ERRORLEVEL 0 GOTO ERROR

IF EXIST C:\lazarus\lazarus.exe (
ECHO.
ECHO ------- Copy Laz64 Executables to Settings -----------
copy /Y C:\lazarus\lazarus.exe ..\binSettings\win64\
IF NOT ERRORLEVEL 0 GOTO ERROR
copy /Y C:\lazarus\startlazarus.exe ..\binSettings\win64\
IF NOT ERRORLEVEL 0 GOTO ERROR
copy /Y C:\lazarus\lazbuild.exe ..\binSettings\win64\
IF NOT ERRORLEVEL 0 GOTO ERROR
ECHO.
ECHO INFO: Lazarus64 IDE Build OK. Have fun.
) ELSE (
ECHO.
ECHO ??????????????????????????????????????????????????????
ECHO ERROR: Lazarus64 IDE NOT Build
ECHO ??????????????????????????????????????????????????????
)

GOTO END

:ERROR
echo ERROR !  %0
exit 1
:END
